#include "typedef.h"

#include <stdio.h>
#include <assert.h>
#include <stdio.h>
#include <string.h>


#include "xmalloc.h"
#include "object.h"
#include "directory.h"
#include "code.h"
#include "source.h"

Csource	*Csource::g_source_headP   = 0;
Csource	**Csource::g_source_tailPP = &g_source_headP;

Csource::Csource(void)
{
	memset(this, 0, sizeof(Csource));
	*g_source_tailPP = this;
	g_source_tailPP  = &m_nextP;
}

void
Csource::emit_ta(void) const
{
	extern FILE	*taF;
	extern FILE	*tempF;

	Cdirectory	*parentP;
	const char	*nameP, *P, *P1;

	parentP = m_parentP;

	if (parentP) {
		// Making the count 2 causes automatic directory to treat as must
		// not be collapsed
		parentP->has_clones(2);
	}
	fprintf(taF, "$INSTANCE S%p S\n", this);
	if (parentP) {
		fprintf(taF, "contain D%p S%p\n", parentP, this);
	}
	nameP = m_filenameP;
	P     = 0;
	for (P1 = nameP; ; ++P1) {
		switch (*P1) {
		case 0:
			break;
		case '/':
			P = P1;
		default:
			continue;
		}
		break;
	}

	if (P && P[1]) {
		nameP = P+1;
	}
	fprintf(tempF, "S%p {label=\"%s\" file=\"./%s\"}\n", this, nameP, nameP);
}
