
class Cclass;
class Cdirectory;

class Csource : public Cobject {
public:
	static Csource	*g_source_headP;
	static Csource	**g_source_tailPP;

	Csource			*m_hashP;
	Csource			*m_nextP;

	u4T				m_strings;
	stringT			*m_stringsP;			// String table for this source
	u4T				m_types;
	stringT			**m_typesPP;
	u4T				m_protos;
	protoT			*m_protosP;
	u4T				m_fields;
	fieldT			*m_fieldsP;
	u4T				m_methods;
	methodT			*m_methodsP;
	u4T				m_classdefs;			// Linked list of class's
	Cclass			*m_classdefsP;			// Classes contained within this source

	const char		*m_filenameP;			// Name of the file actually read

	Cdirectory		*m_parentP;				// Directory containing this source
	
	int				m_has_clones;			// 0 if no clones under this

	Csource(void);

	void			set_register(registerT *registerP, u4T index) const;
	void			set_string(registerT *registerP, u4T index) const;
	void			set_type(registerT *registerP, u4T index) const;
	void			set_field(registerT *registerP, u4T index) const;
	void			set_method(registerT *registerP, u4T index) const;

	int				load(const char *pathP, int dynamic);

	void			emit_ta(void) const;
};

int	readclassfile(const char *pathP, Cclass *classP);
void pseudo_source(void);
