
#if defined(WIN32)

//#define TRACK_DOWN_MALLOC_PROBLEM
#define _CRT_SECURE_NO_DEPRECATE

typedef signed char			s1T;
typedef unsigned char		u1T;
typedef unsigned short		u2T;
typedef signed   short      s2T;
typedef unsigned __int32	u4T;
typedef signed   __int32	s4T;
typedef unsigned __int64	u8T;
typedef signed   __int64	s8T;

#define U2len(X)			wcslen((wchar_t *) X)
#define U2cmp(X, Y)			wcscmp((wchar_t *) X, (wchar_t *) Y)
#else

typedef signed char			s1T;
typedef unsigned char		u1T;
typedef unsigned short		u2T;
typedef signed short		s2T;
typedef unsigned int		u4T;
typedef signed int			s4T;
typedef unsigned long long	u8T;
typedef signed   long long	s8T;

// Because on linux sizeof(wchar_t) == 4 -- not 2
#define U2len(X)			unicodelth(X)
#define U2cmp(X, Y)			unicodecmp(X, Y)

#define HIGH_ENDIAN

#endif

typedef struct {
	u4T		lth;
	u2T		*P;	// Converted from MUTF-8 representation into unicode up front
} stringT;

#define HASHSIZE 0x400

