class Csource;
class Cclone;
class Cfile;

class Cfunction : public Cobject {
public:
	Cclass		*m_classP;
	methodT		*m_methodP;
	u4T			m_access_flags;

	// the number of registers used by this code 
	u2T			m_registers;
	// the number of words of incoming arguments to the method that this code is for 
	u2T			m_incoming; 
	// the number of words of outgoing argument space required by this code for method invocation  
	u2T			m_outgoing;  
	// the number of try_items for this instance. If non-zero, then these appear as the tries array just after the insns in this instance.  
	u2T			m_tries;
	u4T			m_parameters;
	stringT		**m_parametersPP;
	// number of debug variables
	u4T			m_variables;
	variableT	*m_variablesP;
	// number of position items
	u4T			m_positions;
	positionT	*m_positionsP;

	// size of the instructions list, in 16-bit code units 
	u4T			m_instructions;
	// size of assemblersP
	u4T			m_assemblers;
	codeT		*m_assemblersP;
	Cclone		*m_clonesP;		// Linked list of clones

protected:
	void		emit_ta(void);
public:
	static void	dump_descriptor(const u2T *descriptorP);
	void		dump_descriptor(void) const;
	Cclone		*locate_clone(const codeT *startP, const codeT *endP);
	static void	dump_pcode(codeT *assemblerP);
};
